<?php
// -----------------------------------------------------------------------
//
// $Id: users.php 110 2012-03-22 11:10:33Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['ADMIN_USERS_TITLE']);

// Administrator ?
if ($users['user_level'] < 4)
{
    error_template($lang['ADMIN_LEVEL_ERROR']);
}
else
{
    // Edit form
    if (isset($_GET['action']) && $_GET['action'] == 'edit_user')
    {
        // Check query
        if (!empty($_GET['user_id']))
        {
            $sql->query('SELECT user_avatar, user_date_format, user_date_offset, user_day, user_email, user_ip, user_language, user_level, user_location, user_month, user_name, user_occupation, user_template, user_viewemail, user_website, user_year
                         FROM ' . TABLE_USERS . '
                         WHERE user_id = \'' . $_GET['user_id'] . '\'');
            $table_users = $sql->fetch();
            // Check user
            if (!$table_users['user_name'])
            {
                error_template($lang['ADMIN_QUERY_ERROR']);
            }
            else
            {
                if ($table_users['user_level'] == 0)
                {
                    $user_level_options = '<option value="0" selected="selected">' . $lang['ADMIN_USERS_LEVEL0'] . '</option><option value="1">' . $lang['ADMIN_USERS_LEVEL1'] . '</option><option value="2">' . $lang['ADMIN_USERS_LEVEL2'] . '</option><option value="3">' . $lang['ADMIN_USERS_LEVEL3'] . '</option><option value="4">' . $lang['ADMIN_USERS_LEVEL4'] . '</option>';
                }
                elseif ($table_users['user_level'] == 1)
                {
                    $user_level_options = '<option value="0">' . $lang['ADMIN_USERS_LEVEL0'] . '</option><option value="1" selected="selected">' . $lang['ADMIN_USERS_LEVEL1'] . '</option><option value="2">' . $lang['ADMIN_USERS_LEVEL2'] . '</option><option value="3">' . $lang['ADMIN_USERS_LEVEL3'] . '</option><option value="4">' . $lang['ADMIN_USERS_LEVEL4'] . '</option>';
                }
                elseif ($table_users['user_level'] == 2)
                {
                    $user_level_options = '<option value="0">' . $lang['ADMIN_USERS_LEVEL0'] . '</option><option value="1">' . $lang['ADMIN_USERS_LEVEL1'] . '</option><option value="2" selected="selected">' . $lang['ADMIN_USERS_LEVEL2'] . '</option><option value="3">' . $lang['ADMIN_USERS_LEVEL3'] . '</option><option value="4">' . $lang['ADMIN_USERS_LEVEL4'] . '</option>';
                }
                elseif ($table_users['user_level'] == 3)
                {
                    $user_level_options = '<option value="0">' . $lang['ADMIN_USERS_LEVEL0'] . '</option><option value="1">' . $lang['ADMIN_USERS_LEVEL1'] . '</option><option value="2">' . $lang['ADMIN_USERS_LEVEL2'] . '</option><option value="3" selected="selected">' . $lang['ADMIN_USERS_LEVEL3'] . '</option><option value="4">' . $lang['ADMIN_USERS_LEVEL4'] . '</option>';
                }
                else
                {
                    $user_level_options = '<option value="0">' . $lang['ADMIN_USERS_LEVEL0'] . '</option><option value="1">' . $lang['ADMIN_USERS_LEVEL1'] . '</option><option value="2">' . $lang['ADMIN_USERS_LEVEL2'] . '</option><option value="3">' . $lang['ADMIN_USERS_LEVEL3'] . '</option><option value="4" selected="selected">' . $lang['ADMIN_USERS_LEVEL4'] . '</option>';
                }

                $languages = get_languages_list();
                $user_language_options = '';
                if ($settings['language_unique'] == 0)
                {
                    for ($i = 0; $i < count($languages); $i++)
                    {
                        if ($languages[$i] != $table_users['user_language'])
                        {
                            $user_language_options .= '<option value="' . $languages[$i] . '">' . $lang['' . strtoupper($languages[$i]) . ''] . '</option>';
                        }
                        else
                        {
                            $user_language_options .= '<option value="' . $languages[$i] . '" selected="selected">' . $lang['' . strtoupper($languages[$i]) . ''] . '</option>';
                        }
                    }
                }
                else
                {
                    $user_language_options = '<option value="' . $settings['language'] . '">' . $lang['' . strtoupper($settings['language']) . ''] . '</option>';
                }

                $templates = get_templates_list();
                $user_template_options = '';
                if ($settings['template_unique'] == 0)
                {
                    for ($i = 0; $i < count($templates); $i++)
                    {
                        if ($templates[$i] != $table_users['user_template'])
                        {
                            $user_template_options .= '<option value="' . $templates[$i] . '">' . $templates[$i] . '</option>';
                        }
                        else
                        {
                            $user_template_options .= '<option value="' . $templates[$i] . '" selected="selected">' . $templates[$i] . '</option>';
                        }
                    }
                }
                else
                {
                    $user_template_options = '<option value="' . $settings['template'] . '">' . $settings['template'] . '</option>';
                }

                if ($table_users['user_viewemail'] == 0)
                {
                    $user_viewemail_options = '<option value="0" selected="selected">' . $lang['NO'] . '</option><option value="1">' . $lang['YES'] . '</option>';
                }
                else
                {
                    $user_viewemail_options = '<option value="0">' . $lang['NO'] . '</option><option value="1" selected="selected">' . $lang['YES'] . '</option>';
                }

                $user_day_options = $user_month_options = $user_year_options = '';
                for ($i = 1; $i <= 31; $i++)
                {
                    if ($i != $table_users['user_day'])
                    {
                        $user_day_options .= '<option value="' . $i . '">' . $i . '</option>';
                    }
                    else
                    {
                        $user_day_options .= '<option value="' . $i . '" selected="selected">' . $i . '</option>';
                    }
                }
                for ($j = 1; $j <= 12; $j++)
                {
                    if ($j != $table_users['user_month'])
                    {
                        $user_month_options .= '<option value="' . $j . '">' . $j . '</option>';
                    }
                    else
                    {
                        $user_month_options .= '<option value="' . $j . '" selected="selected">' . $j . '</option>';
                    }
                }
                for ($k = date('Y', time()); $k >= 1895; $k--)
                {
                    if ($k != $table_users['user_year'])
                    {
                        $user_year_options .= '<option value="' . $k . '">' . $k . '</option>';
                    }
                    else
                    {
                        $user_year_options .= '<option value="' . $k . '" selected="selected">' . $k . '</option>';
                    }
                }
                if ($table_users['user_avatar'] != './../images/avatars/empty.png')
                {
                    $empty_avatar = '&nbsp;<input type="checkbox" name="empty_avatar" value="1" />&nbsp;' . $lang['DELETE'];
                }
                else
                {
                    $empty_avatar = '';
                }
                $template->set_file('admin', 'admin/users/edit.htpl');
                $template->set_var(array('ADMIN_USERS_HEADER2' => $lang['ADMIN_USERS_HEADER2'],
                                         'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED'],
                                         'EDIT' => $lang['EDIT'],
                                         'EMPTY_AVATAR' => $empty_avatar,
                                         'FORM_CURRENT_AVATAR' => $lang['FORM_CURRENT_AVATAR'],
                                         'FORM_USER_BIRTHDAY' => $lang['FORM_USER_BIRTHDAY'],
                                         'FORM_USER_DATE_FORMAT' => $lang['FORM_USER_DATE_FORMAT'],
                                         'FORM_USER_DATE_OFFSET' => $lang['FORM_USER_DATE_OFFSET'],
                                         'FORM_USER_DAY' => $lang['FORM_USER_DAY'],
                                         'FORM_USER_EMAIL' => $lang['FORM_USER_EMAIL'],
                                         'FORM_USER_IP' => $lang['FORM_USER_IP'],
                                         'FORM_USER_LANGUAGE' => $lang['FORM_USER_LANGUAGE'],
                                         'FORM_USER_LEVEL' => $lang['FORM_USER_LEVEL'],
                                         'FORM_USER_LOCATION' => $lang['FORM_USER_LOCATION'],
                                         'FORM_USER_MONTH' => $lang['FORM_USER_MONTH'],
                                         'FORM_USER_NAME' => $lang['FORM_USER_NAME'],
                                         'FORM_USER_OCCUPATION' => $lang['FORM_USER_OCCUPATION'],
                                         'FORM_USER_TEMPLATE' => $lang['FORM_USER_TEMPLATE'],
                                         'FORM_USER_VIEWEMAIL' => $lang['FORM_USER_VIEWEMAIL'],
                                         'FORM_USER_WEBSITE' => $lang['FORM_USER_WEBSITE'],
                                         'FORM_USER_YEAR' => $lang['FORM_USER_YEAR'],
                                         'USER_AVATAR' => $table_users['user_avatar'],
                                         'USER_DATE_FORMAT' => $table_users['user_date_format'],
                                         'USER_DATE_OFFSET' => $table_users['user_date_offset'],
                                         'USER_DAY_OPTIONS' => $user_day_options,
                                         'USER_EMAIL' => $table_users['user_email'],
                                         'USER_ID' => $_GET['user_id'],
                                         'USER_IP' => $table_users['user_ip'],
                                         'USER_LANGUAGE_OPTIONS' => $user_language_options,
                                         'USER_LEVEL_OPTIONS' => $user_level_options,
                                         'USER_LOCATION' => $table_users['user_location'],
                                         'USER_MONTH_OPTIONS' => $user_month_options,
                                         'USER_NAME' => $table_users['user_name'],
                                         'USER_OCCUPATION' => $table_users['user_occupation'],
                                         'USER_TEMPLATE_OPTIONS' => $user_template_options,
                                         'USER_VIEWEMAIL_OPTIONS' => $user_viewemail_options,
                                         'USER_WEBSITE' => $table_users['user_website'],
                                         'USER_YEAR_OPTIONS' => $user_year_options));
                $template->parse('admin');
            }
        }
        else
        {
            error_template($lang['ADMIN_QUERY_ERROR']);
        }
    }
    // Edit ?
    elseif (isset($_POST['edit_user']))
    {
        $error = '';
        if (!trim($_POST['user_name']))
        {
            $error .= $lang['NO_USER_NAME'];
        }
        if (!trim($_POST['user_email']))
        {
            $error .= $lang['NO_USER_EMAIL'];
        }
        if (!trim($_POST['user_date_format']))
        {
            $error .= $lang['NO_DATE_FORMAT'];
        }
        if (!preg_match('`^-?[0-9]{1,2}$`', $_POST['user_date_offset']))
        {
            $error .= $lang['NO_DATE_OFFSET'];
        }
        if ($error)
        {
            error_template($error);
        }
        else
        {
            if (isset($_POST['empty_avatar']))
            {
                $user_avatar = './../images/avatars/empty.png';
                if ($_POST['user_avatar'] != $user_avatar)
                {
                    unlink($_POST['user_avatar']);
                }
            }
            else
            {
                $user_avatar = $_POST['user_avatar'];
            }
            $sql->query('UPDATE ' . TABLE_USERS . '
                         SET user_avatar = \'' . $user_avatar . '\', user_date_format = \'' . $_POST['user_date_format'] . '\', user_date_offset = \'' . $_POST['user_date_offset'] . '\', user_day = \'' . $_POST['user_day'] . '\', user_email = \'' . $_POST['user_email'] . '\', user_language = \'' . $_POST['user_language'] . '\', user_level = \'' . $_POST['user_level'] . '\', user_location = \'' . chars2entities($_POST['user_location'], ENT_QUOTES) . '\', user_month = \'' . $_POST['user_month'] . '\', user_name = \'' . chars2entities($_POST['user_name'], ENT_QUOTES) . '\', user_occupation = \'' . chars2entities($_POST['user_occupation'], ENT_QUOTES) . '\', user_template = \'' . $_POST['user_template'] . '\', user_viewemail = \'' . $_POST['user_viewemail'] . '\', user_website = \'' . $_POST['user_website'] . '\', user_year = \'' . $_POST['user_year'] . '\'
                         WHERE user_id = \'' . $_POST['user_id'] . '\'');
            success_template($lang['ADMIN_USERS_EDITED'], './../admin/advanced.php');
        }
    }
    // Delete ?
    elseif (isset($_GET['action']) && $_GET['action'] == 'delete_user')
    {
        // Check query
        if (!empty($_GET['user_id']))
        {
            $sql->query('SELECT user_comments, user_name, user_posts
                         FROM ' . TABLE_USERS . '
                         WHERE user_id = \'' . $_GET['user_id'] . '\'');
            $table_users = $sql->fetch();
            // Check user
            if (!$table_users['user_name'])
            {
                error_template($lang['ADMIN_QUERY_ERROR']);
            }
            else
            {
                if ($table_users['user_comments'] != 0 || $table_users['user_posts'] != 0)
                {
                    error_template($lang['ADMIN_USERS_ERROR']);
                }
                else
                {
                    $i = 0;
                    $query[0] = $query[1] = array();
                    $sql->query('SELECT COUNT(*) AS votes_per_answer, answer_id, question_id
                                 FROM ' . TABLE_VOTES . '
                                 WHERE user_id = \'' . $_GET['user_id'] . '\'
                                 GROUP BY answer_id
                                 ORDER BY answer_id');
                    while ($table_votes = $sql->fetch())
                    {
                        $query[0][$i] = 'UPDATE ' . TABLE_ANSWERS . '
                                         SET answer_votes = answer_votes - ' . $table_votes['votes_per_answer'] . '
                                         WHERE answer_id = \'' . $table_votes['answer_id'] . '\'';
                        $query[1][$i] = 'UPDATE ' . TABLE_QUESTIONS . '
                                         SET question_votes = question_votes - ' . $table_votes['votes_per_answer'] . '
                                         WHERE question_id = \'' . $table_votes['question_id'] . '\'';
                        $i++;
                    }
                    for ($j = 0; $j < $i; $j++)
                    {
                        $sql->query($query[0][$j]);
                        $sql->query($query[1][$j]);
                    }
                    $sql->query('DELETE FROM ' . TABLE_VOTES . '
                                 WHERE user_id = \'' . $_GET['user_id'] . '\'');
                    $sql->query('DELETE FROM ' . TABLE_USERS . '
                                 WHERE user_id = \'' . $_GET['user_id'] . '\'');
                    success_template($lang['ADMIN_USERS_DELETED'], './../admin/advanced.php');
                }
            }
        }
        else
        {
            error_template($lang['ADMIN_QUERY_ERROR']);
        }
    }
    // Purge ?
    elseif (isset($_GET['action']) && $_GET['action'] == 'purge_users')
    {
        $accounts_expiry = time() - ($settings['accounts_expiry'] * 24 * 3600);
        $sql->query('DELETE FROM ' . TABLE_USERS . '
                     WHERE user_creation < \'' . $accounts_expiry . '\'
                     AND user_level = \'0\'
                     AND user_key <> \'0\'');
        success_template($lang['ADMIN_USERS_PURGED'], './../admin/advanced.php');
    }
    // Users list
    else
    {
        // Create pages list
        if (empty($_GET['page']))
        {
            $_GET['page'] = 1;
        }
        $users_per_page = $settings['users_per_page'];
        $users_offset = ($_GET['page'] - 1) * $users_per_page;
        $sql->query('SELECT user_id
                     FROM ' . TABLE_USERS);
        $num_users = $sql->num_rows();
        $num_pages = ceil($num_users / $users_per_page);
        $pages_list = get_pages_list('./../admin/users.php?', $num_pages);

        $template->set_file('admin', 'admin/users/view.htpl');
        $template->set_block('admin', 'USERS_BLOCK', 'users');
        $sql->query('SELECT user_id, user_level, user_name
                     FROM ' . TABLE_USERS . '
                     ORDER BY user_level, user_name
                     LIMIT ' . $users_offset . ', ' . $users_per_page);
        while ($table_users = $sql->fetch())
        {
            if ($table_users['user_level'] == 0)
            {
                $user_image = './../images/admin/banned.png';
            }
            elseif ($table_users['user_level'] == 1)
            {
                $user_image = './../images/admin/public.png';
            }
            elseif ($table_users['user_level'] == 2)
            {
                $user_image = './../images/admin/moderator.png';
            }
            elseif ($table_users['user_level'] == 3)
            {
                $user_image = './../images/admin/advanced_moderator.png';
            }
            else
            {
                $user_image = './../images/admin/administrator.png';
            }
            $template->set_var(array('DELETE' => $lang['DELETE'],
                                     'EDIT' => $lang['EDIT'],
                                     'USER_ID' => $table_users['user_id'],
                                     'USER_IMAGE' => $user_image,
                                     'USER_NAME' => $table_users['user_name']));
            $template->parse('USERS_BLOCK', 'users', true);
        }
        $template->set_var(array('ADMIN_USERS_HEADER1' => $lang['ADMIN_USERS_HEADER1'],
                                 'ADMIN_USERS_PAGES' => sprintf($lang['ADMIN_USERS_PAGES'], $pages_list),
                                 'BACK_ADMIN_ADVANCED' => $lang['BACK_ADMIN_ADVANCED']));
        $template->parse('admin');
    }
}

page_footer();

?>