<?php
// -----------------------------------------------------------------------
//
// $Id: list.php 76 2012-02-25 13:55:12Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['POSTS_LIST_TITLE']);

// Check query
if (!empty($_GET['category_id']))
{
    $sql->query('SELECT category_level, category_name
                 FROM ' . TABLE_CATEGORIES . '
                 WHERE category_id = \'' . $_GET['category_id'] . '\'');
    $table_categories = $sql->fetch();
    // Forum categories ?
    if ($table_categories['category_level'] >= 1)
    {
        // Private category - administrators only
        if ($table_categories['category_level'] == 3 && $users['user_level'] < 4)
        {
            error_template($lang['POSTS_LIST_ERROR1']);
        }
        else
        {
            // Create pages list
            if (empty($_GET['page']))
            {
                $_GET['page'] = 1;
            }
            $threads_per_page = $settings['threads_per_page'];
            $threads_offset = ($_GET['page'] - 1) * $threads_per_page;
            $sql->query('SELECT DISTINCT thread_id
                         FROM ' . TABLE_POSTS . '
                         WHERE category_id = \'' . $_GET['category_id'] . '\'');
            $num_threads = $sql->num_rows();
            $num_pages = ceil($num_threads / $threads_per_page);
            $pages_list = get_pages_list('./../posts/list.php?category_id=' . $_GET['category_id'] . '&amp;', $num_pages);

            // First ids, names and dates are allocated to threads
            $creation_first = array();
            $first_id = array();
            $first_name = array();
            $sql->query('SELECT ' . TABLE_POSTS . '.post_creation, ' . TABLE_POSTS . '.thread_id, ' . TABLE_USERS . '.user_id, ' . TABLE_USERS . '.user_name
                         FROM ' . TABLE_POSTS . ', ' . TABLE_USERS . '
                         WHERE ' . TABLE_POSTS . '.category_id = \'' . $_GET['category_id'] . '\'
                         AND ' . TABLE_POSTS . '.user_id = ' . TABLE_USERS . '.user_id
                         AND ' . TABLE_POSTS . '.post_creation
                         IN (SELECT MIN(post_creation)
                             FROM ' . TABLE_POSTS . '
                             WHERE ' . TABLE_POSTS . '.category_id = \'' . $_GET['category_id'] . '\'
                             GROUP BY thread_id)
                         ORDER BY thread_id');
            while ($table_posts = $sql->fetch())
            {
                $creation_first[$table_posts['thread_id']] = $table_posts['post_creation'];
                $first_id[$table_posts['thread_id']] = $table_posts['user_id'];
                $first_name[$table_posts['thread_id']] = $table_posts['user_name'];
            }

            // Last ids, names and dates are allocated to threads
            $creation_last = array();
            $last_id = array();
            $last_name = array();
            $sql->query('SELECT ' . TABLE_POSTS . '.post_creation, ' . TABLE_POSTS . '.thread_id, ' . TABLE_USERS . '.user_id, ' . TABLE_USERS . '.user_name
                         FROM ' . TABLE_POSTS . ', ' . TABLE_USERS . '
                         WHERE ' . TABLE_POSTS . '.category_id = \'' . $_GET['category_id'] . '\'
                         AND ' . TABLE_POSTS . '.user_id = ' . TABLE_USERS . '.user_id
                         AND ' . TABLE_POSTS . '.post_creation
                         IN (SELECT MAX(post_creation)
                             FROM ' . TABLE_POSTS . '
                             WHERE ' . TABLE_POSTS . '.category_id = \'' . $_GET['category_id'] . '\'
                             GROUP BY thread_id)
                         ORDER BY thread_id');
            while ($table_posts = $sql->fetch())
            {
                $creation_last[$table_posts['thread_id']] = $table_posts['post_creation'];
                $last_id[$table_posts['thread_id']] = $table_posts['user_id'];
                $last_name[$table_posts['thread_id']] = $table_posts['user_name'];
            }

            // Images are allocated to threads
            $folder_image = array();
            $sql->query('SELECT DISTINCT thread_id, post_active, post_sticky
                         FROM ' . TABLE_POSTS . '
                         WHERE category_id = \'' . $_GET['category_id'] . '\'');
            while ($table_posts = $sql->fetch())
            {
                    // Closed thread ?
                    if ($table_posts['post_active'] == 0)
                    {
                        // Sticky post ?
                        if ($table_posts['post_sticky'] == 0)
                        {
                            $folder_image[$table_posts['thread_id']] = './../images/posts/folder_closed.png';
                        }
                        else
                        {
                            $folder_image[$table_posts['thread_id']] = './../images/posts/sticky_closed.png';
                        }
                    }
                    else
                    {
                        if ($table_posts['post_sticky'] == 0)
                        {
                            $folder_image[$table_posts['thread_id']] = './../images/posts/folder.png';
                        }
                        else
                        {
                            $folder_image[$table_posts['thread_id']] = './../images/posts/sticky.png';
                        }
                    }
            }
            // User logged ?
            if ($_SESSION['user_id'] != 0)
            {
                $sql->query('SELECT DISTINCT thread_id, post_active, post_sticky
                             FROM ' . TABLE_POSTS . '
                             WHERE category_id = \'' . $_GET['category_id'] . '\'
                             AND post_creation > ' . $users['user_lastvisit']);
                while ($table_posts = $sql->fetch())
                {
                    // Closed thread ?
                    if ($table_posts['post_active'] == 0)
                    {
                        // Sticky post ?
                        if ($table_posts['post_sticky'] == 0)
                        {
                            $folder_image[$table_posts['thread_id']] = './../images/posts/folder_new_closed.png';
                        }
                        else
                        {
                            $folder_image[$table_posts['thread_id']] = './../images/posts/sticky_new_closed.png';
                        }
                    }
                    else
                    {
                        if ($table_posts['post_sticky'] == 0)
                        {
                            $folder_image[$table_posts['thread_id']] = './../images/posts/folder_new.png';
                        }
                        else
                        {
                            $folder_image[$table_posts['thread_id']] = './../images/posts/sticky_new.png';
                        }
                    }
                }
            }

            if ($settings['allow_html'] == 0)
            {
                $html_support = $lang['HTML_DISABLED'];
            }
            else
            {
                $html_support = $lang['HTML_ENABLED'];
            }
            $date_format = get_date_format();
            $date_offset = get_date_offset();
            $template->set_file('list', 'posts/list.htpl');
            $template->set_block('list', 'THREADS_BLOCK', 'threads');
            // PostgreSQL - columns not used in an aggregate expression have to be in GROUP BY clause
            // thread_id, post_subject & post_sticky
            $sql->query('SELECT COUNT(*) AS posts_per_thread, MAX(post_creation) AS last_post, post_subject, thread_id
                         FROM ' . TABLE_POSTS . '
                         WHERE category_id = \'' . $_GET['category_id'] . '\'
                         GROUP BY thread_id, post_subject, post_sticky
                         ORDER BY post_sticky DESC, last_post DESC
                         LIMIT ' . $threads_offset . ', ' . $threads_per_page);
            while ($table_posts = $sql->fetch())
            {
                $first_creation = date($date_format, ($creation_first[$table_posts['thread_id']] + $date_offset));
                $last_creation = date($date_format, ($creation_last[$table_posts['thread_id']] + $date_offset));
                $template->set_var(array('FIRST_CREATION' => $first_creation,
                                         'FIRST_ID' => $first_id[$table_posts['thread_id']],
                                         'FIRST_NAME' => $first_name[$table_posts['thread_id']],
                                         'FOLDER_IMAGE' => $folder_image[$table_posts['thread_id']],
                                         'LAST_CREATION' => $last_creation,
                                         'LAST_ID' => $last_id[$table_posts['thread_id']],
                                         'LAST_LIST' => ceil(ceil($table_posts['posts_per_thread'] / $settings['posts_per_page']) / $settings['pages_limit']) - 1,
                                         'LAST_NAME' => $last_name[$table_posts['thread_id']],
                                         'LAST_PAGE' => ceil($table_posts['posts_per_thread'] / $settings['posts_per_page']),
                                         'NUM_REPLIES' => $table_posts['posts_per_thread'] - 1,
                                         'POST_SUBJECT' => $table_posts['post_subject'],
                                         'THREAD_ID' => $table_posts['thread_id']));
                $template->parse('THREADS_BLOCK', 'threads', true);
                $threads_exist = true;
            }

            $template->set_var(array('ADD' => $lang['ADD'],
                                     'BACK_CATEGORIES_INDEX' => $lang['BACK_CATEGORIES_INDEX'],
                                     'BACK_HOME' => $lang['BACK_HOME'],
                                     'CATEGORY_ID' => $_GET['category_id'],
                                     'CATEGORY_NAME' => $table_categories['category_name'],
                                     'FORM_IN_SUBJECT' => $lang['FORM_IN_SUBJECT'],
                                     'FORM_IN_TEXT' => $lang['FORM_IN_TEXT'],
                                     'FORM_POST_SUBJECT' => $lang['FORM_POST_SUBJECT'],
                                     'FORM_POST_TEXT' => $lang['FORM_POST_TEXT'],
                                     'HTML_SUPPORT' => $html_support,
                                     'POSTS_LIST_FIRST_POST' => $lang['POSTS_LIST_FIRST_POST'],
                                     'POSTS_LIST_HEADER' => $lang['POSTS_LIST_HEADER'],
                                     'POSTS_LIST_LAST_PAGE' => $lang['POSTS_LIST_LAST_PAGE'],
                                     'POSTS_LIST_LAST_POST' => $lang['POSTS_LIST_LAST_POST'],
                                     'POSTS_LIST_REPLIES' => $lang['POSTS_LIST_REPLIES'],
                                     'POSTS_LIST_THREADS' => $lang['POSTS_LIST_THREADS'],
                                     'PREVIEW' => $lang['PREVIEW'],
                                     'SEARCH' => $lang['SEARCH'],
                                     'SMILIES_LIST' => get_smilies_list(0)));

            if (isset($threads_exist))
            {
                $template->set_var('POSTS_LIST_PAGES', sprintf($lang['POSTS_LIST_PAGES'], $pages_list));
            }
            else
            {
                $template->set_var('POSTS_LIST_PAGES', $lang['POSTS_LIST_ERROR2']);
            }
            $template->parse('list');
        }
    }
    else
    {
        error_template($lang['POSTS_LIST_ERROR3']);
    }
}
else
{
    error_template($lang['POSTS_LIST_ERROR4']);
}

page_footer();

?>