<?php
// -----------------------------------------------------------------------
//
// $Id: profile.php 49 2012-02-16 16:56:15Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['USERS_PROFILE_TITLE']);

// User logged ?
if ($_SESSION['user_id'] != 0)
{
    // From profile form ?
    if (isset($_POST['profile']))
    {
        $error = '';
        $max_avatars_pixels = $settings['max_avatars_pixels'];
        $tmp_name = $_FILES['user_avatar2']['tmp_name'];
        $upload_dir = './../images/avatars/';
        $upload_name = $_FILES['user_avatar2']['name'];
        $upload_file = $upload_dir . $upload_name;
        $upload_ext = substr($upload_name, strrpos($upload_name, '.'));
        $valid_ext = array('.gif', '.GIF', '.jpg', '.JPG', '.jpeg', '.JPEG', '.png', '.PNG');
        // New password ?
        if (!empty($_POST['user_password']))
        {
            // Password too short ?
            if (strlen(trim($_POST['user_password'])) < $settings['min_passwords_length'])
            {
                $error .= sprintf($lang['USERS_PROFILE_ERROR1'], $settings['min_passwords_length']);
            }
            // Passwords ok ?
            if (trim($_POST['user_password2']) != trim($_POST['user_password']))
            {
                $error .= $lang['USERS_PROFILE_ERROR2'];
            }
            if (trim($_POST['user_password2']) == trim($_POST['user_password']))
            {
                $new_password = true;
            }
        }
        if (!trim($_POST['user_email']))
        {
            $error .= $lang['NO_USER_EMAIL'];
        }
        else
        {
            if (check_email($_POST['user_email']))
            {
                $user_email = $_POST['user_email'];
            }
            else
            {
                $error .= $lang['INVALID_USER_EMAIL'];
            }
        }
        if (!trim($_POST['user_date_format']))
        {
            $error .= $lang['NO_DATE_FORMAT'];
        }
        if (!preg_match('`^-?[0-9]{1,2}$`', $_POST['user_date_offset']))
        {
            $error .= $lang['NO_DATE_OFFSET'];
        }
        // Check new avatar
        if (!empty($upload_name))
        {
            // Check directory permissions
            if (!is_writable($upload_dir))
            {
                $error .= sprintf($lang['USERS_PROFILE_ERROR4'], $upload_dir);
            }
            // Check duplicate image
            if (file_exists($upload_file))
            {
                $error .= $lang['USERS_PROFILE_ERROR5'];
            }
            // Check image format
            if (!in_array($upload_ext, $valid_ext))
            {
                $error .= $lang['INVALID_IMAGE_FILE'];
            }
            // Check image size
            $size = getimagesize($tmp_name);
            if ($size[0] > $max_avatars_pixels || $size[1] > $max_avatars_pixels)
            {
                $error .= sprintf($lang['USERS_PROFILE_ERROR6'], $max_avatars_pixels);
            }
        }
        if ($error)
        {
            error_template($error);
        }
        else
        {
            if (isset($new_password))
            {
                $sql->query('UPDATE ' . TABLE_USERS . '
                             SET user_date_format = \'' . $_POST['user_date_format'] . '\', user_date_offset = \'' . $_POST['user_date_offset'] . '\', user_day = \'' . $_POST['user_day'] . '\', user_email = \'' . $user_email . '\', user_ip = \'' . $_SERVER['REMOTE_ADDR'] . '\', user_language = \'' . $_POST['user_language'] . '\', user_location = \'' . chars2entities($_POST['user_location'], ENT_QUOTES) . '\', user_month = \'' . $_POST['user_month'] . '\', user_occupation = \'' . chars2entities($_POST['user_occupation'], ENT_QUOTES) . '\', user_password = \'' . sha1($_POST['user_password']) . '\', user_template = \'' . $_POST['user_template'] . '\', user_viewemail = \'' . $_POST['user_viewemail'] . '\', user_website = \'' . $_POST['user_website'] . '\', user_year = \'' . $_POST['user_year'] . '\'
                             WHERE user_id = \'' . $_SESSION['user_id'] . '\'');
            }
            else
            {
                $sql->query('UPDATE ' . TABLE_USERS . '
                             SET user_date_format = \'' . $_POST['user_date_format'] . '\', user_date_offset = \'' . $_POST['user_date_offset'] . '\', user_day = \'' . $_POST['user_day'] . '\', user_email = \'' . $user_email . '\', user_ip = \'' . $_SERVER['REMOTE_ADDR'] . '\', user_language = \'' . $_POST['user_language'] . '\', user_location = \'' . chars2entities($_POST['user_location'], ENT_QUOTES) . '\', user_month = \'' . $_POST['user_month'] . '\', user_occupation = \'' . chars2entities($_POST['user_occupation'], ENT_QUOTES) . '\', user_template = \'' . $_POST['user_template'] . '\', user_viewemail = \'' . $_POST['user_viewemail'] . '\', user_website = \'' . $_POST['user_website'] . '\', user_year = \'' . $_POST['user_year'] . '\'
                             WHERE user_id = \'' . $_SESSION['user_id'] . '\'');
            }
            if (!empty($upload_name))
            {
                if (move_uploaded_file($tmp_name, $upload_file))
                {
                    // Delete old avatar
                    if ($_POST['user_avatar'] != './../images/avatars/empty.png')
                    {
                        unlink($_POST['user_avatar']);
                    }
                    $sql->query('UPDATE ' . TABLE_USERS . '
                                 SET user_avatar = \'' . $upload_file . '\'
                                 WHERE user_id = \'' . $_SESSION['user_id'] . '\'');
                }
                else
                {
                    error_template($lang['USERS_PROFILE_ERROR7']);
                }
            }
            else
            {
                if (isset($_POST['empty_avatar']))
                {
                    $user_avatar = './../images/avatars/empty.png';
                    if ($_POST['user_avatar'] != $user_avatar)
                    {
                        unlink($_POST['user_avatar']);
                    }
                }
                else
                {
                    $user_avatar = $_POST['user_avatar'];
                }
                $sql->query('UPDATE ' . TABLE_USERS . '
                             SET user_avatar = \'' . $user_avatar . '\'
                             WHERE user_id = \'' . $_SESSION['user_id'] . '\'');
            }
            success_template($lang['USERS_PROFILE_SUCCESS'], './../index.php');
        }
    }
    // Profile form
    else
    {
        $languages = get_languages_list();
        $templates = get_templates_list();
        $user_language_options = $user_template_options = '';
        $user_day_options = $user_month_options = $user_year_options = '';
        if ($settings['language_unique'] == 0)
        {
            for ($i = 0; $i < count($languages); $i++)
            {
                if ($languages[$i] != $users['user_language'])
                {
                    $user_language_options .= '<option value="' . $languages[$i] . '">' . $lang['' . strtoupper($languages[$i]) . ''] . '</option>';
                }
                else
                {
                    $user_language_options .= '<option value="' . $languages[$i] . '" selected="selected">' . $lang['' . strtoupper($languages[$i]) . ''] . '</option>';
                }
            }
        }
        else
        {
            $user_language_options = '<option value="' . $settings['language'] . '">' . $lang['' . strtoupper($settings['language']) . ''] . '</option>';
        }
        if ($settings['template_unique'] == 0)
        {
            for ($i = 0; $i < count($templates); $i++)
            {
                if ($templates[$i] != $users['user_template'])
                {
                    $user_template_options .= '<option value="' . $templates[$i] . '">' . $templates[$i] . '</option>';
                }
                else
                {
                    $user_template_options .= '<option value="' . $templates[$i] . '" selected="selected">' . $templates[$i] . '</option>';
                }
            }
        }
        else
        {
            $user_template_options = '<option value="' . $settings['template'] . '">' . $settings['template'] . '</option>';
        }
        if ($users['user_viewemail'] == 0)
        {
            $no_selected = ' selected="selected"';
            $yes_selected = '';
        }
        else
        {
            $no_selected = '';
            $yes_selected = ' selected="selected"';
        }
        for ($i = 1; $i <= 31; $i++)
        {
            if ($i != $users['user_day'])
            {
                $user_day_options .= '<option value="' . $i . '">' . $i . '</option>';
            }
            else
            {
                $user_day_options .= '<option value="' . $i . '" selected="selected">' . $i . '</option>';
            }
        }
        for ($j = 1; $j <= 12; $j++)
        {
            if ($j != $users['user_month'])
            {
                $user_month_options .= '<option value="' . $j . '">' . $j . '</option>';
            }
            else
            {
                $user_month_options .= '<option value="' . $j . '" selected="selected">' . $j . '</option>';
            }
        }
        for ($k = date('Y', time()); $k >= 1895; $k--)
        {
            if ($k != $users['user_year'])
            {
                $user_year_options .= '<option value="' . $k . '">' . $k . '</option>';
            }
            else
            {
                $user_year_options .= '<option value="' . $k . '" selected="selected">' . $k . '</option>';
            }
        }
        if ($users['user_avatar'] != './../images/avatars/empty.png')
        {
            $empty_avatar = '&nbsp;<input type="checkbox" name="empty_avatar" value="1" />&nbsp;' . $lang['DELETE'];
        }
        else
        {
            $empty_avatar = '';
        }
        $template->set_file('profile', 'users/profile.htpl');
        $template->set_var(array('BACK_HOME' => $lang['BACK_HOME'],
                                 'EDIT' => $lang['EDIT'],
                                 'EMPTY_AVATAR' => $empty_avatar,
                                 'FORM_CURRENT_AVATAR' => $lang['FORM_CURRENT_AVATAR'],
                                 'FORM_USER_AVATAR' => $lang['FORM_USER_AVATAR'],
                                 'FORM_USER_BIRTHDAY' => $lang['FORM_USER_BIRTHDAY'],
                                 'FORM_USER_DATE_FORMAT' => $lang['FORM_USER_DATE_FORMAT'],
                                 'FORM_USER_DATE_OFFSET' => $lang['FORM_USER_DATE_OFFSET'],
                                 'FORM_USER_DAY' => $lang['FORM_USER_DAY'],
                                 'FORM_USER_EMAIL' => $lang['FORM_USER_EMAIL'],
                                 'FORM_USER_LANGUAGE' => $lang['FORM_USER_LANGUAGE'],
                                 'FORM_USER_LOCATION' => $lang['FORM_USER_LOCATION'],
                                 'FORM_USER_MONTH' => $lang['FORM_USER_MONTH'],
                                 'FORM_USER_NAME' => $lang['FORM_USER_NAME'],
                                 'FORM_USER_OCCUPATION' => $lang['FORM_USER_OCCUPATION'],
                                 'FORM_USER_PASSWORD' => $lang['FORM_USER_PASSWORD'],
                                 'FORM_USER_PASSWORD2' => $lang['FORM_USER_PASSWORD2'],
                                 'FORM_USER_TEMPLATE' => $lang['FORM_USER_TEMPLATE'],
                                 'FORM_USER_VIEWEMAIL' => $lang['FORM_USER_VIEWEMAIL'],
                                 'FORM_USER_WEBSITE' => $lang['FORM_USER_WEBSITE'],
                                 'FORM_USER_YEAR' => $lang['FORM_USER_YEAR'],
                                 'NO' => $lang['NO'],
                                 'NO_SELECTED' => $no_selected,
                                 'USER_AVATAR' => $users['user_avatar'],
                                 'USER_DATE_FORMAT' => $users['user_date_format'],
                                 'USER_DATE_OFFSET' => $users['user_date_offset'],
                                 'USER_DAY_OPTIONS' => $user_day_options,
                                 'USER_EMAIL' => $users['user_email'],
                                 'USER_LANGUAGE_OPTIONS' => $user_language_options,
                                 'USER_LOCATION' => $users['user_location'],
                                 'USER_MONTH_OPTIONS' => $user_month_options,
                                 'USER_NAME' => $users['user_name'],
                                 'USER_OCCUPATION' => $users['user_occupation'],
                                 'USER_TEMPLATE_OPTIONS' => $user_template_options,
                                 'USER_WEBSITE' => $users['user_website'],
                                 'USER_YEAR_OPTIONS' => $user_year_options,
                                 'USERS_PROFILE_HEADER' => $lang['USERS_PROFILE_HEADER'],
                                 'YES' => $lang['YES'],
                                 'YES_SELECTED' => $yes_selected));
        $template->parse('profile');
    }
}
else
{
    error_template($lang['USERS_PROFILE_ERROR3']);
}

page_footer();

?>